<template>
    <div id="app">
        <div v-if="init">
            <Header></Header>
            <div class="app-wrapper">
                <div class="huge-logo-wrapper" v-if="hidePlayer">
                    <img width="500px" src="./assets/logo.jpg">
                </div>
                <div v-if="!playerSingleView" class="router-section app-section">
                    <router-view></router-view>
                </div>
                <div v-if="!hidePlayer" v-bind:class="{ 'player-full-view' : playerSingleView, 'player-split-view' : !playerSingleView }" class="app-section">
                    <h2 class="visuallyhidden">Player</h2>
                    <Player></Player>
                </div>
            </div>
        </div>
</div>
</template>

<script>
    import './assets/style.scss'
    import WS from './websocket_con'
    import Header from './components/presentational/header'
    import Player from './components/player/player'

    export default {
        name: 'app',
        data() {
            return {
                init: false,
                openCon: false,
                playerSingleView: {
                    type: Boolean,
                    default: false
                },
                hidePlayer: {
                    type: Boolean,
                    default: false
                }
            }
        },
        components: {
            Header,
            Player,

        },

        beforeCreate(){
            WS.connect().then(() => {this.init = true;});
        },

        updated(){

        },

        created() {
            if(this.$router.currentRoute.fullPath === '/player'){
                this.playerSingleView = true;
            } else{
                this.playerSingleView = false;
            }
            if(this.$router.currentRoute.fullPath === '/'){
                this.hidePlayer = true;
            } else {
                this.hidePlayer = false;
            }
        },

        watch:{
            $route (){
                if(this.$router.currentRoute.fullPath === '/player'){
                    this.playerSingleView = true;
                } else {
                    this.playerSingleView = false;
                }
                if(this.$router.currentRoute.fullPath === '/'){
                    this.hidePlayer = true;
                } else {
                    this.hidePlayer = false;
                }

            }
        },

        methods: {

        },
        beforeDestroy() {
            WS.disconnect();
        },

    }
</script>

<style lang="scss">
    @import "/assets/theme";

    #app {
        font-family: 'Roboto', Helvetica, Arial, sans-serif;
        -webkit-font-smoothing: antialiased;
        -moz-osx-font-smoothing: grayscale;
        font-weight: 800;
        letter-spacing: 0.7px;
        /*text-align: center;*/
        color: #2c3e50;

    }
    .app-wrapper{
        display: flex;
        margin-top: 45px;
    }

    .player-split-view {
        width: 33.33333333333%;
        background-color: $PRIMARY-COLOUR;
        position: fixed;
        right: 0;
        top: 45px;
        height: calc(100vh - 45px);

        .player {
            + .section {
                background-color: red;
                color: $WHITE;
            }
        }

        .list {
            color: $WHITE;
        }

        .curr-listening {
            display: none;
        }
        .leave-huge {
            display: none;
        }
    }
    .player-full-view{
        width: 100%;

        .leave-tiny {
            display: none;
        }

        .player-section {
            order: 2;
            min-height: calc(100vh - 45px);
            max-height: calc(100vh - 45px);
            overflow: hidden;

        }

        .list-section {
            order: 1;
            background-image: url("assets/images/background_white.png");
            background-attachment: fixed;
            background-size: 100% auto;
            background-position: bottom;
            background-repeat: no-repeat;

        }
    }

    .router-section {
        width: 66.66666666%;
        background-image: url("assets/images/background_white.png");
        background-attachment: fixed;
        background-size: 100% auto;
        background-position: bottom;
        background-repeat: no-repeat;
        min-height: calc(100vh - 45px);
    }


    .huge-logo-wrapper {
        height: calc(100vh - 45px);
        display: flex;
        justify-content: center;
        width: 66.66666%;

        img {
            height: 100%;
            width: auto;
        }

        + .router-section {
            background-image: none;
            width: 33.333333%;
        }
    }
</style>
